<template>
  <main>
    <mt-controle-activites
      :type-activite-selected="typeActiviteSelected"
      :is-my-activities="isMyActivities"
      :date-courante="currentMonthDate"
      @filtrer-type-activite="filtrerTypeActivite"
      @filtrer-my-activities="filtrerMyActivities"
    />
    <mt-box-activites
      :date-courante="currentMonthDate"
      :groupes="groupes"
      :selected-groupes="groupesSelected"
      @mois-selectionne="moisSelectionne"
      @select-groupes="filtrerGroupe"
    >
      <mt-calendar
        class="mt-box-activites-calendar"
        :disponibilites="disponibilites"
        :current-month-date="currentMonthDate"
        :activites="activites"
        :is-my-activities="isMyActivities"
        :selected-groupes="groupesSelected"
        @view-change="onViewChange"
        @disponibilite-choisie="disponibiliteChoisie"
      />
    </mt-box-activites>
    <mt-nouveaute v-if="!isMobile" :affichage="nouveautes" :sondage="sondage"></mt-nouveaute>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import MtBoxActivites from '~/components/activity/box-activites';
import MtCalendar from '~/components/calendar/index';
import MtControleActivites from '~/components/activity/controle-activites';
import { calendarParent, requetesAsyncDataCommunes } from '~/components/mixins/calendarMixin';
import userMixin from '~/components/mixins/userMixin';
import MtNouveaute from '~/components/nouveaute/index';

export default {
  components: {
    MtNouveaute,
    MtBoxActivites,
    MtCalendar,
    MtControleActivites,
  },
  mixins: [calendarParent, userMixin],
  data() {
    return {
      typeActiviteSelected: [],
      isMyActivities: false,
    };
  },
  watch: {
    typeActiviteSelected: {
      handler() {
        this.reloadActivite();
      },
      deep: true,
    },
    organisme: {
      handler() {
        this.reloadActivite();
      },
      immediate: true,
    },
    profil: {
      handler() {
        this.nouveautes = this.$store.getters['context/nouveautes'];
      },
      immediate: true,
    },
  },
  watchQuery: ['mois'],
  async asyncData(context) {
    const [nouveautes, sondage] = await Promise.all([
      context.$api.nouveautes.me(),
      context.$api.sondage.dernierSondage(),
    ]);
    const isMobile = context.store.getters['context/isMobile'];
    const groupes = await context.$api.utilisateur().groupes();
    const groupesSelected = JSON.parse(JSON.stringify(context.store.getters['context/groupesSelected']));
    const moisCourant =
      context.query && context.query.mois ? DateTime.fromFormat(context.query.mois, 'yyyy-MM').toJSDate() : new Date();
    const [activites, disponibilites] = await requetesAsyncDataCommunes(context, moisCourant, false);
    return {
      sondage,
      nouveautes,
      activites,
      disponibilites,
      currentMonthDate: moisCourant,
      isMobile,
      groupes,
      groupesSelected,
    };
  },
  methods: {
    async disponibiliteChoisie(data) {
      try {
        if (data.typeDisponibilite.id === null) {
          await this.$api.disponibilites.delete(this.utilisateur.id, data.dateDebut, data.dateFin);
        } else {
          await this.$api.utilisateur().postDisponibilite(data);
        }
        this.reloadActivite();
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    filtrerTypeActivite(newValue) {
      this.typeActiviteSelected = newValue;
      this.reloadActivite();
    },
    filtrerMyActivities(newValue) {
      this.isMyActivities = newValue;
      this.reloadActivite();
    },
    moisSelectionne(ctx) {
      this.onViewChange(ctx);
      this.$router.replace({
        query: { mois: DateTime.fromJSDate(ctx.startDate).toFormat('yyyy-MM') },
      });
    },
    async reloadActivite() {
      [this.activites, this.disponibilites] = await requetesAsyncDataCommunes(
        {
          store: this.$store,
          $api: this.$api,
          idtypeActivite: this.typeActiviteSelected,
          isMyActivities: this.isMyActivities,
        },
        this.currentMonthDate,
      );
    },
    filtrerGroupe(groupes) {
      this.groupeSelected = groupes;
      this.$store.dispatch('context/setGroupesSelected', JSON.parse(JSON.stringify(groupes)));
      this.reloadActivite();
    },
  },
};
</script>
<style lang="scss" scoped>
.mt-box-activites-calendar {
  padding: 1rem;
}
</style>
